/*
 * This file is part of FGGL.
 *
 * FGGL is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 *
 * FGGL is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with FGGL.
 * If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef FGGL_GFX_VULKAN_VULKAN_HPP
#define FGGL_GFX_VULKAN_VULKAN_HPP

#include <memory>

#include <fggl/app.hpp>

#include <vulkan/vulkan.hpp>
#include <vulkan/vulkan_raii.hpp>

namespace fggl::gfx::vkgfx {

	constexpr char const *EngineName = "FGGL";

	class VulkanGraphics {

		private:
			vk::raii::Instance m_instance;
			std::unique_ptr<vk::raii::SwapchainKHR> m_swapchain;
	};

	class VulkanContext {
		public:
			VulkanContext();

			VulkanGraphics &createGraphics();

		private:
			vk::raii::Context m_context;
	};

}

#endif
